/*****************************************************************************
 * This file is part of gfxprim library.                                     *
 *                                                                           *
 * Gfxprim is free software; you can redistribute it and/or                  *
 * modify it under the terms of the GNU Lesser General Public                *
 * License as published by the Free Software Foundation; either              *
 * version 2.1 of the License, or (at your option) any later version.        *
 *                                                                           *
 * Gfxprim is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Lesser General Public License for more details.                           *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public          *
 * License along with gfxprim; if not, write to the Free Software            *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,                        *
 * Boston, MA  02110-1301  USA                                               *
 *                                                                           *
 * Copyright (C) 2011-2013 Cyril Hrubis <metan@ucw.cz>                       *
 * Copyright (C) 2011      Tomas Gavenciak <gavento@ucw.cz>                  *
 *                                                                           *
 *****************************************************************************/

/*
 * GP_Convert.gen.h
 *
 * GENERATED on Mon Dec 23 05:05:53 2013 from GP_Convert.gen.h.t
 * DO NOT MODIFY THIS FILE DIRECTLY!
 *
 * Convert PixelType values macros and functions
 */
#ifndef GP_CONVERT_GEN_H
#define GP_CONVERT_GEN_H
#include "GP_GetSetBits.h"
#include "GP_Context.h"
#include "GP_Pixel.h"

/*** RGB888 -> xRGB8888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (xRGB8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_xRGB8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_xRGB8888(p1, p2) \
        GP_Pixel_RGB888_TO_xRGB8888_OFFSET(p1, 0, p2, 0)


/*** xRGB8888 -> RGB888 ***
 * macro reads p1 (xRGB8888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_xRGB8888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_xRGB8888_TO_RGB888(p1, p2) \
        GP_Pixel_xRGB8888_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> RGBA8888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGB888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> RGB888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_RGB888(p1, p2) \
        GP_Pixel_RGB888_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> BGR888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (BGR888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_BGR888_OFFSET(p1, o1, p2, o2) do { \
        /* B:=B */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* R:=R */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_BGR888(p1, p2) \
        GP_Pixel_RGB888_TO_BGR888_OFFSET(p1, 0, p2, 0)


/*** BGR888 -> RGB888 ***
 * macro reads p1 (BGR888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_BGR888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_BGR888_TO_RGB888(p1, p2) \
        GP_Pixel_BGR888_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> RGB555 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB555 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_RGB555_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(10+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_RGB555(p1, p2) \
        GP_Pixel_RGB888_TO_RGB555_OFFSET(p1, 0, p2, 0)


/*** RGB555 -> RGB888 ***
 * macro reads p1 (RGB555 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB555_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(10+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(5+o1, 5, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB555_TO_RGB888(p1, p2) \
        GP_Pixel_RGB555_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> RGB565 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB565 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_RGB565_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(11+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_RGB565(p1, p2) \
        GP_Pixel_RGB888_TO_RGB565_OFFSET(p1, 0, p2, 0)


/*** RGB565 -> RGB888 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB565_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB565_TO_RGB888(p1, p2) \
        GP_Pixel_RGB565_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> RGB666 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB666 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_RGB666_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(12+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(6+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_RGB666(p1, p2) \
        GP_Pixel_RGB888_TO_RGB666_OFFSET(p1, 0, p2, 0)


/*** RGB666 -> RGB888 ***
 * macro reads p1 (RGB666 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB666_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(12+o1, 6, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(6+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(0+o1, 6, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB666_TO_RGB888(p1, p2) \
        GP_Pixel_RGB666_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> RGB332 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB332 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_RGB332_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(5+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(2+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_RGB332(p1, p2) \
        GP_Pixel_RGB888_TO_RGB332_OFFSET(p1, 0, p2, 0)


/*** RGB332 -> RGB888 ***
 * macro reads p1 (RGB332 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB332_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(5+o1, 3, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(2+o1, 3, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB332_TO_RGB888(p1, p2) \
        GP_Pixel_RGB332_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> CMYK8888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (CMYK8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_CMYK8888_OFFSET(p1, o1, p2, o2) do { \
	GP_Pixel _R = GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)); \
	GP_Pixel _G = GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)); \
	GP_Pixel _B = GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)); \
	GP_Pixel _K = GP_MAX3(_R, _G, _B); \
	GP_SET_BITS(0+o2, 8, p2, GP_SCALE_VAL_8_8((_K - _R))); \
	GP_SET_BITS(8+o2, 8, p2, GP_SCALE_VAL_8_8((_K - _G))); \
	GP_SET_BITS(16+o2, 8, p2, GP_SCALE_VAL_8_8((_K - _B))); \
	GP_SET_BITS(24+o2, 8, p2, GP_SCALE_VAL_8_8(255 - _K)); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_CMYK8888(p1, p2) \
        GP_Pixel_RGB888_TO_CMYK8888_OFFSET(p1, 0, p2, 0)


/*** CMYK8888 -> RGB888 ***
 * macro reads p1 (CMYK8888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_CMYK8888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
	GP_SET_BITS(16+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(0+o1, 8, p1)))) / (0xff * 0xff)); \
	GP_SET_BITS(8+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(8+o1, 8, p1)))) / (0xff * 0xff)); \
	GP_SET_BITS(0+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(16+o1, 8, p1)))) / (0xff * 0xff)); \
} while (0)

/* a version without offsets */
#define GP_Pixel_CMYK8888_TO_RGB888(p1, p2) \
        GP_Pixel_CMYK8888_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> G1 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G1 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_G1_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 1, p2, ( \
                /* R */ GP_SCALE_VAL_8_1(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_1(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_1(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_G1(p1, p2) \
        GP_Pixel_RGB888_TO_G1_OFFSET(p1, 0, p2, 0)


/*** G1 -> RGB888 ***
 * macro reads p1 (G1 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G1_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G1_TO_RGB888(p1, p2) \
        GP_Pixel_G1_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> G2 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G2 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_G2_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_G2(p1, p2) \
        GP_Pixel_RGB888_TO_G2_OFFSET(p1, 0, p2, 0)


/*** G2 -> RGB888 ***
 * macro reads p1 (G2 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G2_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G2_TO_RGB888(p1, p2) \
        GP_Pixel_G2_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> G4 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G4 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_G4_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 4, p2, ( \
                /* R */ GP_SCALE_VAL_8_4(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_4(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_4(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_G4(p1, p2) \
        GP_Pixel_RGB888_TO_G4_OFFSET(p1, 0, p2, 0)


/*** G4 -> RGB888 ***
 * macro reads p1 (G4 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G4_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G4_TO_RGB888(p1, p2) \
        GP_Pixel_G4_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> G8 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_G8(p1, p2) \
        GP_Pixel_RGB888_TO_G8_OFFSET(p1, 0, p2, 0)


/*** G8 -> RGB888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G8_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G8_TO_RGB888(p1, p2) \
        GP_Pixel_G8_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGB888 -> G16 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G16 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB888_TO_G16_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 16, p2, ( \
                /* R */ GP_SCALE_VAL_8_16(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_16(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_16(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB888_TO_G16(p1, p2) \
        GP_Pixel_RGB888_TO_G16_OFFSET(p1, 0, p2, 0)


/*** G16 -> RGB888 ***
 * macro reads p1 (G16 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G16_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G16_TO_RGB888(p1, p2) \
        GP_Pixel_G16_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*
 * Convert RGB888 to any other PixelType
 * Does not work on palette types at all (yet)
 */
GP_Pixel GP_RGB888ToPixel(GP_Pixel pixel, GP_PixelType type);

/*
 * Function converting to RGB888 from any other PixelType
 * Does not work on palette types at all (yet)
 */
GP_Pixel GP_PixelToRGB888(GP_Pixel pixel, GP_PixelType type);

/*** RGBA8888 -> xRGB8888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (xRGB8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_xRGB8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_xRGB8888(p1, p2) \
        GP_Pixel_RGBA8888_TO_xRGB8888_OFFSET(p1, 0, p2, 0)


/*** xRGB8888 -> RGBA8888 ***
 * macro reads p1 (xRGB8888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_xRGB8888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_xRGB8888_TO_RGBA8888(p1, p2) \
        GP_Pixel_xRGB8888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> RGBA8888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* A:=A */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGBA8888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> RGB888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_RGB888(p1, p2) \
        GP_Pixel_RGBA8888_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> BGR888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (BGR888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_BGR888_OFFSET(p1, o1, p2, o2) do { \
        /* B:=B */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* R:=R */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_BGR888(p1, p2) \
        GP_Pixel_RGBA8888_TO_BGR888_OFFSET(p1, 0, p2, 0)


/*** BGR888 -> RGBA8888 ***
 * macro reads p1 (BGR888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_BGR888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_BGR888_TO_RGBA8888(p1, p2) \
        GP_Pixel_BGR888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> RGB555 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB555 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_RGB555_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(10+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_RGB555(p1, p2) \
        GP_Pixel_RGBA8888_TO_RGB555_OFFSET(p1, 0, p2, 0)


/*** RGB555 -> RGBA8888 ***
 * macro reads p1 (RGB555 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB555_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(10+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(5+o1, 5, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB555_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGB555_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> RGB565 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB565 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_RGB565_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(11+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_RGB565(p1, p2) \
        GP_Pixel_RGBA8888_TO_RGB565_OFFSET(p1, 0, p2, 0)


/*** RGB565 -> RGBA8888 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB565_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB565_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGB565_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> RGB666 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB666 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_RGB666_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(12+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(6+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_RGB666(p1, p2) \
        GP_Pixel_RGBA8888_TO_RGB666_OFFSET(p1, 0, p2, 0)


/*** RGB666 -> RGBA8888 ***
 * macro reads p1 (RGB666 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB666_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(12+o1, 6, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(6+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(0+o1, 6, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB666_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGB666_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> RGB332 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB332 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_RGB332_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(5+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(2+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_RGB332(p1, p2) \
        GP_Pixel_RGBA8888_TO_RGB332_OFFSET(p1, 0, p2, 0)


/*** RGB332 -> RGBA8888 ***
 * macro reads p1 (RGB332 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB332_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(5+o1, 3, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(2+o1, 3, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB332_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGB332_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> CMYK8888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (CMYK8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_CMYK8888_OFFSET(p1, o1, p2, o2) do { \
	GP_Pixel _R = GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1)); \
	GP_Pixel _G = GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)); \
	GP_Pixel _B = GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)); \
	GP_Pixel _K = GP_MAX3(_R, _G, _B); \
	GP_SET_BITS(0+o2, 8, p2, GP_SCALE_VAL_8_8((_K - _R))); \
	GP_SET_BITS(8+o2, 8, p2, GP_SCALE_VAL_8_8((_K - _G))); \
	GP_SET_BITS(16+o2, 8, p2, GP_SCALE_VAL_8_8((_K - _B))); \
	GP_SET_BITS(24+o2, 8, p2, GP_SCALE_VAL_8_8(255 - _K)); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_CMYK8888(p1, p2) \
        GP_Pixel_RGBA8888_TO_CMYK8888_OFFSET(p1, 0, p2, 0)


/*** CMYK8888 -> RGBA8888 ***
 * macro reads p1 (CMYK8888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_CMYK8888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
	GP_SET_BITS(24+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(0+o1, 8, p1)))) / (0xff * 0xff)); \
	GP_SET_BITS(16+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(8+o1, 8, p1)))) / (0xff * 0xff)); \
	GP_SET_BITS(8+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(16+o1, 8, p1)))) / (0xff * 0xff)); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_CMYK8888_TO_RGBA8888(p1, p2) \
        GP_Pixel_CMYK8888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> G1 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G1 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_G1_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 1, p2, ( \
                /* R */ GP_SCALE_VAL_8_1(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_1(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_1(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_G1(p1, p2) \
        GP_Pixel_RGBA8888_TO_G1_OFFSET(p1, 0, p2, 0)


/*** G1 -> RGBA8888 ***
 * macro reads p1 (G1 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G1_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G1_TO_RGBA8888(p1, p2) \
        GP_Pixel_G1_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> G2 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G2 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_G2_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_G2(p1, p2) \
        GP_Pixel_RGBA8888_TO_G2_OFFSET(p1, 0, p2, 0)


/*** G2 -> RGBA8888 ***
 * macro reads p1 (G2 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G2_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G2_TO_RGBA8888(p1, p2) \
        GP_Pixel_G2_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> G4 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G4 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_G4_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 4, p2, ( \
                /* R */ GP_SCALE_VAL_8_4(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_4(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_4(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_G4(p1, p2) \
        GP_Pixel_RGBA8888_TO_G4_OFFSET(p1, 0, p2, 0)


/*** G4 -> RGBA8888 ***
 * macro reads p1 (G4 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G4_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G4_TO_RGBA8888(p1, p2) \
        GP_Pixel_G4_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> G8 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_G8(p1, p2) \
        GP_Pixel_RGBA8888_TO_G8_OFFSET(p1, 0, p2, 0)


/*** G8 -> RGBA8888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G8_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G8_TO_RGBA8888(p1, p2) \
        GP_Pixel_G8_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> G16 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G16 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_G16_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 16, p2, ( \
                /* R */ GP_SCALE_VAL_8_16(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_16(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_16(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_G16(p1, p2) \
        GP_Pixel_RGBA8888_TO_G16_OFFSET(p1, 0, p2, 0)


/*** G16 -> RGBA8888 ***
 * macro reads p1 (G16 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_G16_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_G16_TO_RGBA8888(p1, p2) \
        GP_Pixel_G16_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*
 * Convert RGBA8888 to any other PixelType
 * Does not work on palette types at all (yet)
 */
GP_Pixel GP_RGBA8888ToPixel(GP_Pixel pixel, GP_PixelType type);

/*
 * Function converting to RGBA8888 from any other PixelType
 * Does not work on palette types at all (yet)
 */
GP_Pixel GP_PixelToRGBA8888(GP_Pixel pixel, GP_PixelType type);

/* Experimental macros testing generated scripts */
/*** RGB565 -> RGBA8888 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGB565_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_Pixel_RGB565_TO_RGBA8888(p1, p2) \
        GP_Pixel_RGB565_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*** RGBA8888 -> G2 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G2 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_Pixel_RGBA8888_TO_G2_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_Pixel_RGBA8888_TO_G2(p1, p2) \
        GP_Pixel_RGBA8888_TO_G2_OFFSET(p1, 0, p2, 0)



#endif  /* GP_CONVERT_GEN_H */
