/*****************************************************************************
 * This file is part of gfxprim library.                                     *
 *                                                                           *
 * Gfxprim is free software; you can redistribute it and/or                  *
 * modify it under the terms of the GNU Lesser General Public                *
 * License as published by the Free Software Foundation; either              *
 * version 2.1 of the License, or (at your option) any later version.        *
 *                                                                           *
 * Gfxprim is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Lesser General Public License for more details.                           *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public          *
 * License along with gfxprim; if not, write to the Free Software            *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,                        *
 * Boston, MA  02110-1301  USA                                               *
 *                                                                           *
 * Copyright (C) 2011-2012 Cyril Hrubis <metan@ucw.cz>                       *
 *                                                                           *
 *****************************************************************************/

/*
 * GP_FnPerBpp.gen.h
 *
 * GENERATED on Mon Dec 23 05:05:54 2013 from GP_FnPerBpp.gen.h.t
 * DO NOT MODIFY THIS FILE DIRECTLY!
 *
 * All FnPerBpp macros
 */
#ifndef GP_FNPERBPP_GEN_H
#define GP_FNPERBPP_GEN_H


/*
 * Macros used to create draving functions from macros.
 */
#define GP_DEF_FN_PER_BPP(fname, MACRO_NAME, fdraw) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 1BPP_LE) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 1BPP_BE) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 2BPP_LE) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 2BPP_BE) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 4BPP_LE) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 4BPP_BE) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 8BPP) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 16BPP) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 24BPP) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 32BPP) \
	GP_DEF_FN_FOR_BPP(fname, MACRO_NAME, fdraw, 18BPP_LE) \




/*
 * Branch on bpp and bit_endian.
 */
#define GP_FN_PER_BPP(FN_NAME, bpp, bit_endian, ...) \
	switch (bpp) { \
	case 32: \
		FN_NAME##_32BPP(__VA_ARGS__); \
	break; \
	case 1: \
		if (bit_endian == GP_BIT_ENDIAN_LE) \
			FN_NAME##_1BPP_LE(__VA_ARGS__); \
		else \
			FN_NAME##_1BPP_BE(__VA_ARGS__); \
	break; \
	case 2: \
		if (bit_endian == GP_BIT_ENDIAN_LE) \
			FN_NAME##_2BPP_LE(__VA_ARGS__); \
		else \
			FN_NAME##_2BPP_BE(__VA_ARGS__); \
	break; \
	case 4: \
		if (bit_endian == GP_BIT_ENDIAN_LE) \
			FN_NAME##_4BPP_LE(__VA_ARGS__); \
		else \
			FN_NAME##_4BPP_BE(__VA_ARGS__); \
	break; \
	case 8: \
		FN_NAME##_8BPP(__VA_ARGS__); \
	break; \
	case 16: \
		FN_NAME##_16BPP(__VA_ARGS__); \
	break; \
	case 18: \
		FN_NAME##_18BPP_LE(__VA_ARGS__); \
	break; \
	case 24: \
		FN_NAME##_24BPP(__VA_ARGS__); \
	break; \
	}

/*
 * Branch on bpp and bit_endian.
 */
#define GP_FN_RET_PER_BPP(FN_NAME, bpp, bit_endian, ...) \
	switch (bpp) { \
	case 32: \
		return FN_NAME##_32BPP(__VA_ARGS__); \
	break; \
	case 1: \
		if (bit_endian == GP_BIT_ENDIAN_LE) \
			return FN_NAME##_1BPP_LE(__VA_ARGS__); \
		else \
			return FN_NAME##_1BPP_BE(__VA_ARGS__); \
	break; \
	case 2: \
		if (bit_endian == GP_BIT_ENDIAN_LE) \
			return FN_NAME##_2BPP_LE(__VA_ARGS__); \
		else \
			return FN_NAME##_2BPP_BE(__VA_ARGS__); \
	break; \
	case 4: \
		if (bit_endian == GP_BIT_ENDIAN_LE) \
			return FN_NAME##_4BPP_LE(__VA_ARGS__); \
		else \
			return FN_NAME##_4BPP_BE(__VA_ARGS__); \
	break; \
	case 8: \
		return FN_NAME##_8BPP(__VA_ARGS__); \
	break; \
	case 16: \
		return FN_NAME##_16BPP(__VA_ARGS__); \
	break; \
	case 18: \
		return FN_NAME##_18BPP_LE(__VA_ARGS__); \
	break; \
	case 24: \
		return FN_NAME##_24BPP(__VA_ARGS__); \
	break; \
	}

#endif  /* GP_FNPERBPP_GEN_H */
