/*****************************************************************************
 * This file is part of gfxprim library.                                     *
 *                                                                           *
 * Gfxprim is free software; you can redistribute it and/or                  *
 * modify it under the terms of the GNU Lesser General Public                *
 * License as published by the Free Software Foundation; either              *
 * version 2.1 of the License, or (at your option) any later version.        *
 *                                                                           *
 * Gfxprim is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Lesser General Public License for more details.                           *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public          *
 * License along with gfxprim; if not, write to the Free Software            *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,                        *
 * Boston, MA  02110-1301  USA                                               *
 *                                                                           *
 * Copyright (C) 2012      Cyril Hrubis <metan@ucw.cz>                       *
 *                                                                           *
 *****************************************************************************/

/*
 * GP_GammaCorrection.gen.h
 *
 * GENERATED on Mon Dec 23 05:05:54 2013 from GP_GammaCorrection.gen.h.t
 * DO NOT MODIFY THIS FILE DIRECTLY!
 *
 * Gamma corrections.
 */
#ifndef GP_GAMMACORRECTION_GEN_H
#define GP_GAMMACORRECTION_GEN_H
extern uint16_t *GP_Gamma8_Linear10;
extern uint8_t  *GP_Linear10_Gamma8;

static inline uint16_t GP_Gamma1ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<7];
}

static inline uint16_t GP_Gamma2ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<6];
}

static inline uint16_t GP_Gamma3ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<5];
}

static inline uint16_t GP_Gamma4ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<4];
}

static inline uint16_t GP_Gamma5ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<3];
}

static inline uint16_t GP_Gamma6ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<2];
}

static inline uint16_t GP_Gamma7ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<1];
}

static inline uint16_t GP_Gamma8ToLinear10(uint8_t val)
{
	return GP_Gamma8_Linear10[val<<0];
}


static inline uint8_t GP_Linear10ToGamma1(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 64)>>7;
}

static inline uint8_t GP_Linear10ToGamma2(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 32)>>6;
}

static inline uint8_t GP_Linear10ToGamma3(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 16)>>5;
}

static inline uint8_t GP_Linear10ToGamma4(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 8)>>4;
}

static inline uint8_t GP_Linear10ToGamma5(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 4)>>3;
}

static inline uint8_t GP_Linear10ToGamma6(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 2)>>2;
}

static inline uint8_t GP_Linear10ToGamma7(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 1)>>1;
}

static inline uint8_t GP_Linear10ToGamma8(uint16_t val)
{
	return (GP_Linear10_Gamma8[val] + 0)>>0;
}


#endif  /* GP_GAMMACORRECTION_GEN_H */
