/*****************************************************************************
 * This file is part of gfxprim library.                                     *
 *                                                                           *
 * Gfxprim is free software; you can redistribute it and/or                  *
 * modify it under the terms of the GNU Lesser General Public                *
 * License as published by the Free Software Foundation; either              *
 * version 2.1 of the License, or (at your option) any later version.        *
 *                                                                           *
 * Gfxprim is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Lesser General Public License for more details.                           *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public          *
 * License along with gfxprim; if not, write to the Free Software            *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,                        *
 * Boston, MA  02110-1301  USA                                               *
 *                                                                           *
 * Copyright (C) 2009-2012 Cyril Hrubis <metan@ucw.cz>                       *
 *                                                                           *
 *****************************************************************************/

/*
 * GP_WritePixel.gen.h
 *
 * GENERATED on Mon Dec 23 05:05:54 2013 from GP_WritePixel.gen.h.t
 * DO NOT MODIFY THIS FILE DIRECTLY!
 *
 * Write Pixels generated header
 */
#ifndef GP_WRITEPIXEL_GEN_H
#define GP_WRITEPIXEL_GEN_H


/*
 * These functions writes cnt pixels using value val starting at start address
 * and additionally (for pixel sizes that are not aligned to the whole bytes)
 * at off offset in the first byte (i.e. byte at the start address).
 */

void GP_WritePixels_1BPP_LE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

void GP_WritePixels_1BPP_BE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

void GP_WritePixels_2BPP_LE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

void GP_WritePixels_2BPP_BE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

void GP_WritePixels_4BPP_LE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

void GP_WritePixels_4BPP_BE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

void GP_WritePixels_8BPP(void *start, size_t cnt, unsigned int val);

void GP_WritePixels_16BPP(void *start, size_t cnt, unsigned int val);

void GP_WritePixels_24BPP(void *start, size_t cnt, unsigned int val);

void GP_WritePixels_32BPP(void *start, size_t cnt, unsigned int val);

void GP_WritePixels_18BPP_LE(void *start, uint8_t off,
                            size_t cnt, unsigned int val);

#endif  /* GP_WRITEPIXEL_GEN_H */
