/*****************************************************************************
 * This file is part of gfxprim library.                                     *
 *                                                                           *
 * Gfxprim is free software; you can redistribute it and/or                  *
 * modify it under the terms of the GNU Lesser General Public                *
 * License as published by the Free Software Foundation; either              *
 * version 2.1 of the License, or (at your option) any later version.        *
 *                                                                           *
 * Gfxprim is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Lesser General Public License for more details.                           *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public          *
 * License along with gfxprim; if not, write to the Free Software            *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,                        *
 * Boston, MA  02110-1301  USA                                               *
 *                                                                           *
 * Copyright (C) 2009-2010 Jiri "BlueBear" Dluhos                            *
 *                         <jiri.bluebear.dluhos@gmail.com>                  *
 *                                                                           *
 * Copyright (C) 2009-2013 Cyril Hrubis <metan@ucw.cz>                       *
 *                                                                           *
 *****************************************************************************/

 /*

   Core include file for loaders API.

  */

#ifndef LOADERS_GP_LOADERS_H
#define LOADERS_GP_LOADERS_H

#include "core/GP_Context.h"
#include "core/GP_ProgressCallback.h"

#include "loaders/GP_PNM.h"
#include "loaders/GP_BMP.h"
#include "loaders/GP_PNG.h"
#include "loaders/GP_JPG.h"
#include "loaders/GP_JP2.h"
#include "loaders/GP_GIF.h"
#include "loaders/GP_TIFF.h"
#include "loaders/GP_PSP.h"

#include "loaders/GP_TmpFile.h"

#include "loaders/GP_MetaData.h"

#include "loaders/GP_Loader.h"

#include "loaders/GP_Container.h"
#include "loaders/GP_ZIP.h"

#endif /* LOADERS_GP_LOADERS_H */
